<script setup lang="ts">
import type { User } from '@/types/User';
import { nextTick, onMounted, ref } from 'vue';
import { VForm } from 'vuetify/lib/components/index.mjs';

const headers = [
    {
        title: 'Id',
        key: 'id',
        value: 'id',
    },
    {
        title: 'Email',
        key: 'email',
        value: 'email'
    },
    {
        title: 'Full name',
        key: 'fullname',
        value: 'fullname'
    }
    ,
    {
        title: 'Gender',
        key: 'gender',
        value: 'gender'
    }
    ,
    {
        title: 'Roles',
        key: 'roles',
        value: (item: any | User) => item.roles.join(', ')
    },
    { title: 'Actions', key: 'actions', sortable: false }
]
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initialUser: User = {
    id: -1,
    email: '',
    password: '',
    fullname: '',
    gender: 'male',
    roles: ['user']
}
const editedUser = ref<User>(JSON.parse(JSON.stringify(initialUser)))
const users = ref<User[]>([])
let editedIndex = -1
let lastId = 4
function onSubmit() {

}
function closeDelete() {
    dialogDelete.value = false
    nextTick(() => {
        editedUser.value = Object.assign({}, initialUser)
    })
}
function deleteItemConfirm() {
    //Delete item from list
    users.value.splice(editedIndex, 1)
    closeDelete()
}
function editItem(item: User) {
    editedIndex = users.value.indexOf(item)
    editedUser.value = Object.assign({}, item)
    dialog.value = true
}
function deleteItem(item: User) {
    editedIndex = users.value.indexOf(item)
    editedUser.value = Object.assign({}, item)
    dialogDelete.value = true
    editedIndex = -1
}
function closeDialog() {
    dialog.value = false
    nextTick(() => {
        editedUser.value = Object.assign({}, initialUser)
        editedIndex = -1
    })
}
async function save() {
    const { valid } = await refForm.value!.validate()

    if (!valid) return

    if (editedIndex > -1) {
        Object.assign(users.value[editedIndex], editedUser.value)
    } else {
        editedUser.value.id = lastId++
        users.value.push(editedUser.value)
    }

    closeDialog()
}



function initialize() {
    users.value = [{
        id: 1,
        email: 'admin@admin.com',
        password: 'admin123',
        fullname: 'Admin',
        gender: 'male',
        roles: ['admin', 'user']
    },
    {
        id: 2,
        email: 'user1@user.com',
        password: 'user12231',
        fullname: 'User1',
        gender: 'female',
        roles: ['user']

    },
    {
        id: 3,
        email: 'user2@user.com',
        password: 'Pasord123',
        fullname: 'User2',
        gender: 'male',
        roles: ['user']

    },
    {
        id: 4,
        email: 'p@p.com',
        password: 'pp',
        fullname: 'User2',
        gender: 'male',
        roles: ['user']

    }
    ]
}
onMounted(() => {
    initialize()
})
</script>
<template>
    <div class="coffee-shop-style">
        <v-data-table :headers="headers" :items="users" style="background-color: rgba(202, 174, 123, 0.582);">
            <template v-slot:top>
                <v-toolbar flat style="background-color: rgba(41, 36, 27, 0.623);">
                    <v-toolbar-title class="users-title"><v-icon>mdi mdi-account</v-icon> Users </v-toolbar-title>
                    <v-divider class="mx-4" inset vertical color="blue darken-2"></v-divider>
                    <v-spacer></v-spacer>
                    <v-dialog v-model="dialog" persistent width="1024">
                        <template v-slot:activator="{ props }">
                            <v-btn color="white" v-bind="props" variant="outlined" class="mr-3">
                            <v-icon>mdi mdi-account-multiple-plus </v-icon> New User
                            </v-btn>
                        </template>
                        <v-card color="rgba(255, 255, 255)">
                            <v-card-title>
                                <span class="text-h5">User Profile</span>
                            </v-card-title>
                            <v-card-text>
                                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                                    <v-container>
                                        <v-row>
                                            <v-col cols="12" sm="12" md="4">
                                                <v-text-field v-model="editedUser.email" :readonly="loading"
                                                    :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                                                    label="Email" color="blue darken-2"></v-text-field>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="4">
                                                <v-text-field v-model="editedUser.fullname" :readonly="loading"
                                                    :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                                                    label="Full name" color="green darken-2"></v-text-field>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="4">
                                                <v-text-field v-model="editedUser.password" :readonly="loading"
                                                    :rules="[(v) => !!v || 'Field is required']" clearable label="Password"
                                                    placeholder="Enter your password"
                                                    color="orange darken-2"></v-text-field>
                                            </v-col>
                                            <v-col cols="12" sm="6">
                                                <v-combobox label="Gender" :items="['male', 'female', 'others']"
                                                    v-model="editedUser.gender" color="pink darken-2"></v-combobox>
                                            </v-col>
                                            <v-col cols="12" sm="6">
                                                <v-combobox v-model="editedUser.roles"
                                                    :items="[{ title: 'Admin', value: 'admin' }, { title: 'User', value: 'user' }]"
                                                    label="Select roles" multiple :return-object="false"
                                                    color="purple darken-2"></v-combobox>
                                            </v-col>
                                        </v-row>

                                    </v-container>

                                </v-form>
                                <small>*indicates required field</small>
                            </v-card-text>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">
                                    Close
                                </v-btn>
                                <v-btn color="blue-darken-1" variant="text" @click="save()">
                                    Save
                                </v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                    <!-- Delete Dialog -->
                    <v-dialog v-model="dialogDelete" max-width="500px">
                        <v-card>
                            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                                <v-spacer></v-spacer>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                </v-toolbar>
            </template>
            <template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" class="me-2" @click="editItem(item)">
                    mdi-pencil
                </v-icon>
                <v-icon size="small" @click="deleteItem(item)">
                    mdi-delete
                </v-icon>
            </template>
            <template v-slot:no-data>
                <v-btn color="primary" @click="initialize">
                    Reset
                </v-btn>
            </template>
        </v-data-table>
    </div>
</template>
<style scoped>
.coffee-shop-style {
    background-color: #f5f5f5;
}

.new-user-btn {
    font-size: 18px;
    font-weight: 520;
    color: white;
}

.users-title {
    font-size: 24px;
    font-weight: 520;
    color: white;
}
</style>